/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Doug Yarrington in early 1992
	See the Modification History for more details

FILE
	auto-config.h

NAME
	auto-config.h for ftEngine. Part of the FilterTop project

DESCRIPTION
	Typedefs and prototypes for access functions.

MODIFICATION HISTORY
	Created by Doug Yarrington

	dd mmm yy	-	xxx	-	patchxx: description of patch
	13 Feb 92	-	DNY -	Setting things up for beta release
	26 Feb 92	-	DNY	-	Removed usage of dialog's refCon, pass long instead
	25 Mar 92	-	CRP	-	No Changes
	
*/	

/*********************************** auto-config.h ******************************/

#ifndef	_autoconfig_
#define	_autoconfig_


/*--------- Typedefs -----------*/

typedef short state;
#define	cfgStNone	0
#define cfgStOk		1
#define cfgStCancel	2
#define cfgStSave	3

/*-------- Prototypes ----------*/

void cfgInit (DialogPtr theD, Handle fCFGh, Handle fVLDh, long *cfgPtr);

state cfgHandleEvent (DialogPtr theD, EventRecord *evt, long cfgPtr);

state cfgFinish (DialogPtr theD, state s, Handle fCFGh, long cfgPtr);

pascal void cfgFindData(Handle fCFGh, OSType type, char *data, long *dataLen );

void ConfigureFilter( short);

#endif