/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Steve J in early 1992
	See the Modification History for more details

FILE
	Globals.h

NAME
	Globals.h for ftEngine. Part of the FilterTop project

DESCRIPTION
	This source file contains code that set up globals for filterTop.c.

MODIFICATION HISTORY
	Created by Steve J

	dd mmm yy	-	xxx	-	patchxx: description of patch
	25 Mar 92	-	CRP	-	No Changes
	
*/	

/*********************************** Cursors.h ******************************/

Boolean	done = false;
MenuHandle	appleMenu;
WindowPtr	ftWindow;
Rect		boundsRect;
RgnHandle	currentRegion = nil;
Rect		sizeRect;
long		sleepTicks = 0;

short			fileCreationChoice = ASK_NEW_NAME;
short			notificationNotChoice = NOP_NOTHING, notificationDoneChoice = DONE_NOTHING;

DialogPtr	generalPrefsDialog, notificationPrefsDialog, fileCreationPrefsDialog;
DialogPtr	progressDialog;
DialogPtr	processPriorityDialog;
DialogPtr	hmFTHelpDialog, hmBuildSuperfiltersDialog, hmSettingFilterOptionsDialog,
			hmShortcutsDialog, hmTopSoftDialog;

MenuHandle	helpMenu, prefsSubmenu;

enum {clear = 0, set = 1};