/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Steve J in early 1992
	See the Modification History for more details

FILE
	Prototypes.h

NAME
	Prototypes.h for ftEngine. Part of the FilterTop project

DESCRIPTION
	This source file contains code that handles the cursor.

MODIFICATION HISTORY
	Created by Steve J

	dd mmm yy	-	xxx	-	patchxx: description of patch
	25 Mar 92	-	CRP	-	Prototyped FilterTop.c
	
*/	

/*********************************** Prototypes.h ******************************/

#ifndef _Prototypes_
#define _Prototypes_

void ToolBoxInit(void);
void WindowSetup(void);
void RectSetup(void);
void MenuSetup(void);
void MainEventLoop(void);
void HandleEvent(void);
void HandleNormalEvent( EventRecord *);
void HandleKeyDown( long, short);
void HandleMenu(long );
void HandleApple( short);
void HandleFile( short);
void HandleTransform(void);
void HandleQuit(void);
void HandleFilters( short);
void HandleWindow( short);
void HandleClick(EventRecord *);
void HandleZoom( WindowPtr, short, Point);
void HandleGoAway( WindowPtr, short, Point);
void HandleGrow(WindowPtr, Point);
void HandleUpdate(WindowPtr);
void HandleActivate(WindowPtr, Boolean);
void HandleNull(void);
void DoAbout(void);

void HandleHighLevelEvent( EventRecord *);

OSErr		HandleConfig(void);


#endif

