/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Chris Priestley in early 1992
	See the Modification History for more details

FILE
	myAEevents.h

NAME
	myAEevents.h for ftEngine. Part of the FilterTop project

DESCRIPTION
	This source file contains code for prototypes that handle
	the required apple events.

MODIFICATION HISTORY
	Created by Chris Priestley

	dd mmm yy	-	xxx	-	patchxx: description of patch
	25 Mar 92	-	CRP	-	No Changes
	
*/	

/*********************************** myAEevents.h ******************************/

#ifndef	_myAEevents_
#define	_myAEevents_

#include <GestaltEqu.h>
#include <AppleEvents.h>

OSErr 			InitAppleEvents( void);
Boolean			CheckAEAvailable( void);

pascal OSErr	HandleOApp( AppleEvent *, AppleEvent *, long );
pascal OSErr	HandleODocs( AppleEvent *, AppleEvent *, long);
pascal OSErr	HandleAEPrint( AppleEvent *, AppleEvent *, long);
pascal OSErr	HandleAEQuit( AppleEvent *, AppleEvent *, long);
OSErr			MyGotRequiredParams( AppleEvent *);
Boolean			MyPrepareToTerminate( void);

void			DoAEError( OSErr);
void			ErrorStringHandler( Str255 );

/****************************************************/

Boolean		MyOpenFile(FSSpec *); 		/* these 4 found in Patch to 0.1 Routines in FilterTop.c */
void		MyOpenFolder(FSSpec *);
void		HandleContentClick( WindowPtr, EventRecord *);

#endif
