/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Chris Priestley in early 1992
	See the Modification History for more details

FILE
	prefs.h

NAME
	prefs.h for ftEngine. Part of the FilterTop project

DESCRIPTION
	This source file contains code for prototypes that handle
	loading and saving preferences.

MODIFICATION HISTORY
	Created by Chris Priestley

	dd mmm yy	-	xxx	-	patchxx: description of patch
	25 Mar 92	-	CRP	-	New File
	
*/	

/*********************************** prefs.h ******************************/

#ifndef	_prefs_
#define	_prefs_

typedef struct {
	Rect	windowRect;
	Point	topLeft;
} WinPrefRec, **WinPrefHandle;

OSErr	GetPrefSpec( void);
OSErr	OpenPrefsFile( short *);
void	GetWindowPref(Rect *, Point *, short);
void	SetWindowPref(Rect *, Point *, short);
 		
#endif
