/* I think this file came mostly out of one of the Develop CD's */


void			DrawICS( Rect, short, ListHandle);
GWorldPtr		MakeNewGWorld( Rect, short);

#define	BYTESIZE	8
#define WIDTHHEIGHT 16

void	DrawICS( dstRect, resID, list)
Rect	dstRect;
short	resID;
ListHandle	list;
	{
	short	depth;
	BitMap	iconMap;
	Rect	tmpRect;
	GWorldPtr	GW;
	Handle	h = NULL;
	
	GW = MakeNewGWorld( dstRect, resID);			/* create off screen bit map */
	
	if ( GW != NULL) {
		tmpRect = (**(GW->portPixMap)).bounds;
		tmpRect.right = tmpRect.left + 16;
		CopyBits( (BitMap *)(*(GW->portPixMap)), &(**list).port->portBits,
					&(tmpRect), &dstRect, srcCopy, NULL);
		DisposeGWorld( GW);
		}
	}



/* create a new offscreen bitmap */
/* setting depth = 0 requests the deepest depth intersecting dstRect */
GWorldPtr	MakeNewGWorld( dstRect, resID)
Rect	dstRect;
short	resID;
{
	Rect		localR;
	Handle		h;
	QDErr		myErr;
	short		i;
	Ptr			p,tp;
	short		depth;
	GWorldPtr	GW = NULL;
	
	localR = dstRect;
	
	/* 
	   by passing a global rectangle we force NewGWorld to determine the resolution
	   of the device the the majority of the rectangle lies on.  Then we can use the pixel
	   depth to determine which icl or ics to get
	*/
	LocalToGlobal((Point *)&localR.top);
	LocalToGlobal((Point *)&localR.bottom);
	
	myErr = NewGWorld( &GW, 0, &localR, NULL, NULL, noNewDevice);
	if( myErr != noErr) return (NULL);
	
	myErr = UpdateGWorld( &GW, 0, &localR, NULL, NULL, 0);
	if( myErr != noErr) return (NULL);
		
	/* now grab the right depth of icl or ics */
	depth = (**(GW->portPixMap)).pixelSize; 
	switch ( depth ) {
		case 1:
			h = GetResource('ics#',resID);
			break;
		case 2:
			DisposeGWorld( GW);
			depth = 1;
			SetRect( &localR, 0, 0, 16, 16);
			myErr = NewGWorld( &GW, depth, &localR, NULL, NULL, 0);
			if( myErr != noErr) return (NULL);
			h = GetResource('ics#',resID);
			break;
		case 4:
			h = GetResource('ics4',resID);
			break;
		case 8:
			h = GetResource('ics8',resID);
			break;
		default:
			DisposeGWorld( GW);
			depth = 8;
			SetRect( &localR, 0, 0, 16, 16);
			myErr = NewGWorld( &GW, depth, &localR, NULL, NULL, 0);
			if( myErr != noErr) return (NULL);
			h = GetResource('ics8',resID);
			break;
		}
		
		/* we will be working with the pixel data directly so lock them */
		p = GetPixBaseAddr(GW->portPixMap);
		if ( p != NULL) {
			HLock( h);
			tp = *h;
			
			/* 
				because NewGWorld usually adds a long word of padding so that
				it can more easily keep the pixel map long word aligned we
				can't just BlockMove the data directly.  Instead we have to
				move one row from our source and then advance the pointer of the
				destination to the next row
			*/
			for (  i = 0; i < WIDTHHEIGHT; i++ ) { 
				BlockMove(tp,p,(WIDTHHEIGHT / BYTESIZE) * depth);		/* move a row */
				/*
				  now advance the destination pointer to the next row.  Don't
				  forget to and off he high bit which marks this as a pixelmap
				 */
				p += ((**(GW->portPixMap)).rowBytes ) & 0x7fff;
				tp += (WIDTHHEIGHT / BYTESIZE) * depth; /*move the source pointer to the next row */
			}
			HUnlock( h);
			ReleaseResource( h);
		}
	return( GW);
	}


