/* 
==========================================================================
     Rename.c
     
     Example filter, converted from ChrisP & PeterL's Rename.p.

     This file was never compiled, I never tested this code; it's
     just a hack, nothing more, nothing less.
==========================================================================
*/


#include "filter.h"

pascal OSErr     main (PBCallToFilter *pb)
{
	OSErr     oe, ooe;
	OSType     creator, ftype;
	FSSpec     fs;

	oe = noErr;
	switch( pb->serviceRequested )
	{
		case msgOpenFilter:     // Set up filterGlobalsH 
			pb->filterGlobalsH = (Handle)0xA5A5A5A5;
			break;

		case msgCloseFilter:       // Destroy filterGlobalsH
			pb->filterGlobalsH = 0L;
			break;

		case msgStartFiltering:
			if (pb->filterGlobalsH != (Handle)0xA5A5A5A5)
				DebugStr("\pBad Filter Globals");
			oe = inProgress;	// Return inProgress so msgFilterAWhile will get called next
			break;

		case msgFinishFiltering:
			if (pb->filterGlobalsH != (Handle)0xA5A5A5A5)
				DebugStr("\pBad Filter Globals");
			break;

		case msgFilterAWhile:
			if (pb->filterGlobalsH != (Handle)0xA5A5A5A5)
				DebugStr("\pBad Filter Globals");
			oe = inProgress;
			oe = pb->cb->GetFSSpec(&fs, &creator, &ftype);
			if (oe == noErr)
			{
				Str63 tname;
				int     i;     // doin that concat thang
				for (i=0;i<=fs.name[0];i++) tname[i] = fs.name[i];
				tname[++tname[0]] = 'P';
				oe = FSpRename( &fs, tname);
				for (i=0; i <= tname[0]; ++i) fs.name[i] = tname[i];
				oe = pb->cb->SetFSSpec( &fs, &creator, &ftype);	/* new callBack for pipeLines */
			}

			break;

		case msgAbortFiltering:
			break;

		case msgInitOptions:
			break;
		
		case msgDialogEvent:
			break;

		case msgCloseOptions:
			break;

		case msgRankThis:
			break;

		otherwise:
			oe = errUnknownMessage;
			break;
	}
	return oe;
}


